mod Mxrd

incl Mtex

incl Mtexxgr

incl Mxgr

rem 
  \para \bf  Arithmetization of Reductions.  \end 

rem 
  \para \bf  Monadic numerals.  \end 

fun Cnm 'Tex_f1_xgr_cnm'
  Cnm(0) = Zt
  Cnm(x+1) = At(Sx,Cnm(x))

fun Dc 
  Dc(Zt) = 0
  Dc At(Sx,t) = Dc(t)+1

pred Nm 
  Nm(Zt)
  Nm At(Sx,t) <- Nm(t)

rem 
  \para \bf  Substitution.  \end 

fun Ar 
  Ar Lx(n,t) = n

fun/3 Sb 'Tex_f3_xgr_sb'
  Sb(Vt(i),e,rs) = Proj(Ar(e),rs,i)
  Sb(Zt,e,rs) = Zt
  Sb(Dt(t1,t2,t3),e,rs) = Dt(Sb(t1,e,rs),Sb(t2,e,rs),Sb(t3,e,rs))
  Sb(Ct(t,ts),e,rs) = Ct(Sb(t,e,rs),Sb(ts,e,rs))
  Sb(At(Sx,t),e,rs) = At(Sx,Sb(t,e,rs))
  Sb(At(Px,t),e,rs) = At(Px,Sb(t,e,rs))
  Sb(At(Fx(n),ts),e,rs) = At(e,Sb(ts,e,rs))
  Sb(At(Lx(n,t),ts),e,rs) = At(Lx(n,t),Sb(ts,e,rs))

rem 
  \para \bf  Auxiliary operations.  \end 

fun Pn 
  Pn(Zt) = Zt
  Pn At(Sx,t) = t

fun/3 Dn 
  Dn(Zt,t2,t3) = t3
  Dn(At(Sx,t1),t2,t3) = t2

pred/2 Nms 
  Nms(n,ts) <-> \ab i i <= n: (1 <= i -> Nm Proj(n,ts,i))

rem 
  \para \bf  One-step reduction.  \end 

fun Rd 
  Rd(Zt) = Zt
  Rd Dt(t1,t2,t3) = Dn(t1,t2,t3) <- Nm(t1)
  Rd Dt(t1,t2,t3) = Dt(Rd(t1),t2,t3) <- ~Nm(t1)
  Rd Ct(t,ts) = Ct(t,Rd(ts)) <- Nm(t)
  Rd Ct(t,ts) = Ct(Rd(t),ts) <- ~Nm(t)
  Rd At(Sx,t) = At(Sx,Rd(t))
  Rd At(Px,t) = Pn(t) <- Nm(t)
  Rd At(Px,t) = At(Px,Rd(t)) <- ~Nm(t)
  Rd At(Lx(n,t),ts) = Sb(t,Lx(n,t),ts) <- Nms(n,ts)
  Rd At(Lx(n,t),ts) = At(Lx(n,t),Rd(ts)) <- ~Nms(n,ts)

